import { Options } from './options';
declare type TransformCallback = (...args: unknown[]) => unknown | unknown[];
declare type MapMethods<T = unknown> = {
    transform(callback: TransformCallback): MapMethods<T>;
    readonly value: T extends [] ? T[] : T;
};
declare type Map = <T = unknown>(keys: string | string[], options?: Options) => MapMethods<T>;
declare const suppress: unique symbol;
declare const map: {
    <T = unknown>(source: Record<string, unknown | unknown[]>, mapperOptions?: Options): Map;
    omitEntries(entries: Record<string, unknown | unknown[]> | Record<string, unknown | unknown[]>[]): Record<string, unknown | unknown[]> | Record<string, unknown | unknown[]>[];
    suppress: typeof suppress;
};
export type { Map, MapMethods, TransformCallback };
export default map;
